/*
 * Go2PartHoleRadius.c
 * 
 * Gocator system communication library
 * Copyright (C) 2013 by LMI Technologies Inc.
 * 
 * Licensed under The MIT License.
 * Redistributions of files must retain the above copyright notice.
 */

#include <z/Go2Measurements/zGo2PartHoleRadius.h>
#include <z/zGo2PartTypes.h>
#include <z/zGo2System.h>
#include <string.h>

/*
 * Go2PartHoleRadius Class 
 */

GO2_EXPORT(Go2Status) Go2PartHoleRadius_Construct(Go2PartHoleRadius* measurement, Go2UInt32 id, Go2Object system)
{
    Go2PartHoleRadius output = zNIL; 
    Go2Status status = zOK; 

    zCHECK(zCalloc(&output, 1, sizeof(Go2PartHoleRadiusClass))); 

    if (!zSUCCESS(status = Go2PartHoleRadius_Init(output, id, system)))
    {
        zCHECK(Go2Object_Destroy(output)); 
        return status; 
    }

    *measurement = output; 

    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2PartHoleRadius_Init(Go2PartHoleRadius measurement, Go2UInt32 id, Go2Object system)
{
    Go2PartHoleRadiusClass* obj = zHANDLE_POINTER(measurement);
    z32u i; 

    zCHECK(Go2PartMeasurement_Init(measurement, GO2_TYPE_PART_HOLE_RADIUS, id, system)); 

    obj->Release = Go2PartHoleRadius_VRelease;
    obj->Read = Go2PartHoleRadius_VRead; 
    obj->Write = Go2PartHoleRadius_VWrite; 

    obj->nominalRadius = 10.0;
    obj->radiusTolerance = 1.0;
    obj->partialDetectionEnabled = GO2_FALSE;

    for (i = 0; i < zCOUNT(obj->refRegions); ++i)
    {
        zCHECK(Go2PartRegion2d_Construct(&obj->refRegions[i], system));
    }
    //construct all ref areas, but initialize the measurement to only use 2
    obj->refRegionCount = 2;

    obj->refRegionsEnabled = GO2_FALSE;
    obj->autoRefRegionEnabled = GO2_TRUE;
    obj->autoTiltCorrectionEnabled = GO2_TRUE;
    obj->tiltXAngle = 0.0;
    obj->tiltYAngle = 0.0;

    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2PartHoleRadius_VRelease(Go2PartHoleRadius measurement)
{
    Go2PartHoleRadiusClass* obj = zHANDLE_POINTER(measurement);
    z32u i; 

    for (i = 0; i < zCOUNT(obj->refRegions); ++i)
    {
        zCHECK(Go2Object_Destroy(obj->refRegions[i])); 
    }

    zCHECK(Go2PartMeasurement_VRelease(measurement));
        
    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2PartHoleRadius_VRead(Go2PartHoleRadius measurement, zXml xml, zXmlItem item)
{
    Go2PartHoleRadiusClass* obj = zHANDLE_POINTER(measurement);
    zXmlItem regionItem = zNIL;

    zCHECK(Go2PartMeasurement_VRead(measurement, xml, item)); 

    obj->refRegionCount = 0; 
    //ensure we at least have one refArea
    zCHECK(!zIS_NIL(regionItem = zXml_Child(xml, item, "RefRegions/RefRegion")));     
    while (!zIS_NIL(regionItem))
    {
        zCHECK(Go2PartRegion2d_Read(obj->refRegions[obj->refRegionCount], xml, regionItem));  
        obj->refRegionCount++;  
        regionItem = zXml_NextSibling(xml, regionItem);
    }
    
    zCHECK(zXml_Child64f(xml, item, "NominalRadius", &obj->nominalRadius)); 
    zCHECK(zXml_Child64f(xml, item, "RadiusTolerance", &obj->radiusTolerance)); 
    zCHECK(zXml_Child32s(xml, item, "PartialDetectionEnabled", &obj->partialDetectionEnabled));

    zCHECK(zXml_Child32s(xml, item, "RefRegionsEnabled", &obj->refRegionsEnabled));
    zCHECK(zXml_Child32s(xml, item, "AutoRefRegionEnabled", &obj->autoRefRegionEnabled));
    zCHECK(zXml_Child32s(xml, item, "AutoTiltCorrectionEnabled", &obj->autoTiltCorrectionEnabled));
    zCHECK(zXml_Child64f(xml, item, "TiltXAngle", &obj->tiltXAngle)); 
    zCHECK(zXml_Child64f(xml, item, "TiltYAngle", &obj->tiltYAngle)); 

    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2PartHoleRadius_VWrite(Go2PartHoleRadius  measurement, zXml xml, zXmlItem item)
{
    Go2PartHoleRadiusClass* obj = zHANDLE_POINTER(measurement);
    zXmlItem regionItem = zNIL;
    zXmlItem refRegionItem = zNIL;
    z32u i; 

    zCHECK(Go2PartMeasurement_VWrite(measurement, xml, item)); 

    zCHECK(zXml_AddItem(xml, item, "RefRegions", &refRegionItem));  
    for (i = 0; i < obj->refRegionCount; ++i)
    {
        zCHECK(zXml_AddItem(xml, refRegionItem, "RefRegion", &regionItem)); 
        zCHECK(Go2PartRegion2d_Write(obj->refRegions[i], xml, regionItem)); 
    }

    zCHECK(zXml_SetChild64f(xml, item, "NominalRadius", obj->nominalRadius)); 
    zCHECK(zXml_SetChild64f(xml, item, "RadiusTolerance", obj->radiusTolerance)); 
    zCHECK(zXml_SetChild32s(xml, item, "PartialDetectionEnabled", obj->partialDetectionEnabled)); 

    zCHECK(zXml_SetChild32s(xml, item, "RefRegionsEnabled", obj->refRegionsEnabled)); 
    zCHECK(zXml_SetChild32s(xml, item, "AutoRefRegionEnabled", obj->autoRefRegionEnabled)); 
    zCHECK(zXml_SetChild32s(xml, item, "AutoTiltCorrectionEnabled", obj->autoTiltCorrectionEnabled)); 
    zCHECK(zXml_SetChild64f(xml, item, "TiltXAngle", obj->tiltXAngle)); 
    zCHECK(zXml_SetChild64f(xml, item, "TiltYAngle", obj->tiltYAngle)); 

    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2PartHoleRadius_SetId(Go2PartHoleRadius measurement, Go2UInt32 id)
{
    return Go2Measurement_SetId(measurement, id); 
}

GO2_EXPORT(Go2UInt32) Go2PartHoleRadius_Id(Go2PartHoleRadius measurement)
{
    return Go2Measurement_Id(measurement); 
}

GO2_EXPORT(Go2Status) Go2PartHoleRadius_SetName(Go2PartHoleRadius measurement, const Go2Char* name)
{
    return Go2Measurement_SetName(measurement, name); 
}

GO2_EXPORT(Go2Status) Go2PartHoleRadius_Name(Go2PartHoleRadius measurement, Go2Char* name, Go2UInt32 capacity)
{
    return Go2Measurement_Name(measurement, name, capacity); 
}

GO2_EXPORT(Go2Status) Go2PartHoleRadius_SetDecisionMin(Go2PartHoleRadius measurement, Go2Double min)
{
    return Go2Measurement_SetDecisionMin(measurement, min); 
}

GO2_EXPORT(Go2Double) Go2PartHoleRadius_DecisionMin(Go2PartHoleRadius measurement)
{
    return Go2Measurement_DecisionMin(measurement); 
}

GO2_EXPORT(Go2Status) Go2PartHoleRadius_SetDecisionMax(Go2PartHoleRadius measurement, Go2Double max)
{
    return Go2Measurement_SetDecisionMax(measurement, max); 
}

GO2_EXPORT(Go2Double) Go2PartHoleRadius_DecisionMax(Go2PartHoleRadius measurement)
{
    return Go2Measurement_DecisionMax(measurement); 
}

GO2_EXPORT(Go2Status) Go2PartHoleRadius_EnableHold(Go2PartHoleRadius measurement, Go2Bool enable)
{
    return Go2Measurement_EnableHold(measurement, enable);  
} 

GO2_EXPORT(Go2Bool) Go2PartHoleRadius_HoldEnabled(Go2PartHoleRadius measurement)
{
    return Go2Measurement_HoldEnabled(measurement);  
}

GO2_EXPORT(Go2Status) Go2PartHoleRadius_EnableSmoothing(Go2PartHoleRadius measurement, Go2Bool enable)
{
    return Go2Measurement_EnableSmoothing(measurement, enable);  
} 

GO2_EXPORT(Go2Bool) Go2PartHoleRadius_SmoothingEnabled(Go2PartHoleRadius measurement)
{
    return Go2Measurement_SmoothingEnabled(measurement);  
} 

GO2_EXPORT(Go2UInt32) Go2PartHoleRadius_SmoothingWindowMin(Go2PartHoleRadius measurement)
{
    return Go2Measurement_SmoothingWindowMin(measurement);  
} 

GO2_EXPORT(Go2UInt32) Go2PartHoleRadius_SmoothingWindowMax(Go2PartHoleRadius measurement)
{
    return Go2Measurement_SmoothingWindowMax(measurement);  
} 

GO2_EXPORT(Go2Status) Go2PartHoleRadius_SetSmoothingWindow(Go2PartHoleRadius measurement, Go2UInt32 window)
{
    return Go2Measurement_SetSmoothingWindow(measurement, window);  
} 

GO2_EXPORT(Go2UInt32) Go2PartHoleRadius_SmoothingWindow(Go2PartHoleRadius measurement)
{
    return Go2Measurement_SmoothingWindow(measurement);  
} 

GO2_EXPORT(Go2UInt32) Go2PartHoleRadius_RefRegionCount(Go2PartHoleRadius measurement)
{
    Go2PartHoleRadiusClass* obj = zHANDLE_POINTER(measurement); 
    return obj->refRegionCount;      
}

GO2_EXPORT(Go2Status) Go2PartHoleRadius_SetRefRegionCount(Go2PartHoleRadius measurement, Go2UInt32 count)
{
    Go2PartHoleRadiusClass* obj = zHANDLE_POINTER(measurement); 
    Go2Status status = GO2_OK;

    if(count > zCOUNT(obj->refRegions)){
        return GO2_ERROR_PARAMETER;
    }
    zCHECK(Go2System_CheckConfigurable(obj->system)); 
    status = Go2System_Set32u(obj->system, &obj->refRegionCount, count, 1, GO2_MAX_REF_REGIONS); 
    zCHECK(Go2System_SetModified(obj->system)); 

    return status;      
}

GO2_EXPORT(Go2PartRegion2d) Go2PartHoleRadius_RefRegionAt(Go2PartHoleRadius measurement, Go2UInt32 index)
{
    Go2PartHoleRadiusClass* obj = zHANDLE_POINTER(measurement); 
    return obj->refRegions[index];      
}

GO2_EXPORT(Go2Double) Go2PartHoleRadius_NominalRadius(Go2PartHoleRadius measurement)
{
    Go2PartHoleRadiusClass* obj = zHANDLE_POINTER(measurement); 
    return obj->nominalRadius;      
}

GO2_EXPORT(Go2Status) Go2PartHoleRadius_SetNominalRadius(Go2PartHoleRadius measurement, Go2Double radius)
{
    Go2PartHoleRadiusClass* obj = zHANDLE_POINTER(measurement); 

    return Go2System_Set64f(obj->system, &obj->nominalRadius, radius, 0.0, z64F_MAX);        
}

GO2_EXPORT(Go2Double) Go2PartHoleRadius_RadiusTolerance(Go2PartHoleRadius measurement)
{
    Go2PartHoleRadiusClass* obj = zHANDLE_POINTER(measurement); 
    return obj->radiusTolerance;      
}

GO2_EXPORT(Go2Status) Go2PartHoleRadius_SetRadiusTolerance(Go2PartHoleRadius measurement, Go2Double tolerance)
{
    Go2PartHoleRadiusClass* obj = zHANDLE_POINTER(measurement); 

    return Go2System_Set64f(obj->system, &obj->radiusTolerance, tolerance, 0.0, z64F_MAX);   
}

GO2_EXPORT(Go2Bool) Go2PartHoleRadius_RefRegionsEnabled(Go2PartHoleRadius measurement)
{
    Go2PartHoleRadiusClass* obj = zHANDLE_POINTER(measurement);

    return obj->refRegionsEnabled;
}

GO2_EXPORT(Go2Status) Go2PartHoleRadius_EnableRefRegions(Go2PartHoleRadius measurement, Go2Bool enable)
{
    Go2PartHoleRadiusClass* obj = zHANDLE_POINTER(measurement);

    zCHECK(Go2System_CheckConfigurable(obj->system)); 
    obj->refRegionsEnabled = enable;
    zCHECK(Go2System_SetModified(obj->system));

    return GO2_OK;
}

GO2_EXPORT(Go2Bool) Go2PartHoleRadius_AutoRefRegionEnabled(Go2PartHoleRadius measurement)
{
    Go2PartHoleRadiusClass* obj = zHANDLE_POINTER(measurement);
    return obj->autoRefRegionEnabled; 
}

GO2_EXPORT(Go2Status) Go2PartHoleRadius_EnableAutoRefRegion(Go2PartHoleRadius measurement, Go2Bool enable)
{
    Go2PartHoleRadiusClass* obj = zHANDLE_POINTER(measurement);

    zCHECK(Go2System_CheckConfigurable(obj->system)); 
    obj->autoRefRegionEnabled = enable; 
    zCHECK(Go2System_SetModified(obj->system)); 

    return GO2_OK;
}

GO2_EXPORT(Go2Bool) Go2PartHoleRadius_AutoTiltCorrectionEnabled(Go2PartHoleRadius measurement)
{
    Go2PartHoleRadiusClass* obj = zHANDLE_POINTER(measurement);
    return obj->autoTiltCorrectionEnabled; 
}

GO2_EXPORT(Go2Status) Go2PartHoleRadius_EnableAutoTiltCorrection(Go2PartHoleRadius measurement, Go2Bool enable)
{
    Go2PartHoleRadiusClass* obj = zHANDLE_POINTER(measurement);

    zCHECK(Go2System_CheckConfigurable(obj->system)); 
    obj->autoTiltCorrectionEnabled = enable; 
    zCHECK(Go2System_SetModified(obj->system)); 

    return GO2_OK;
}

GO2_EXPORT(Go2Double) Go2PartHoleRadius_TiltXAngle(Go2PartHoleRadius measurement)
{
    Go2PartHoleRadiusClass* obj = zHANDLE_POINTER(measurement);
    return obj->tiltXAngle; 
}

GO2_EXPORT(Go2Status) Go2PartHoleRadius_SetTiltXAngle( Go2PartHoleRadius measurement, Go2Double tiltXAngle )
{
    Go2PartHoleRadiusClass* obj = zHANDLE_POINTER(measurement); 

    return Go2System_Set64f(obj->system, &obj->tiltXAngle, tiltXAngle, -z64F_MAX, z64F_MAX);   
}

GO2_EXPORT(Go2Double) Go2PartHoleRadius_TiltYAngle(Go2PartHoleRadius measurement)
{
    Go2PartHoleRadiusClass* obj = zHANDLE_POINTER(measurement);
    return obj->tiltYAngle; 
}

GO2_EXPORT(Go2Status) Go2PartHoleRadius_SetTiltYAngle(Go2PartHoleRadius measurement, Go2Double tiltYAngle)
{
    Go2PartHoleRadiusClass* obj = zHANDLE_POINTER(measurement); 

    return Go2System_Set64f(obj->system, &obj->tiltYAngle, tiltYAngle, -z64F_MAX, z64F_MAX);   
}

GO2_EXPORT(Go2Status) Go2PartHoleRadius_SetScale(Go2PartHoleRadius measurement, Go2Double scale){
    return Go2Measurement_SetScale(measurement, scale);
}

GO2_EXPORT(Go2Double) Go2PartHoleRadius_Scale(Go2PartHoleRadius measurement){
    return Go2Measurement_Scale(measurement);
}

GO2_EXPORT(Go2Status) Go2PartHoleRadius_SetOffset(Go2PartHoleRadius measurement, Go2Double offset){
    return Go2Measurement_SetOffset(measurement, offset);
}

GO2_EXPORT(Go2Double) Go2PartHoleRadius_Offset(Go2PartHoleRadius measurement){
    return Go2Measurement_Offset(measurement);
}

GO2_EXPORT(Go2Status) Go2PartHoleRadius_EnablePartialDetection(Go2PartHoleRadius measurement, Go2Bool enabled) 
{
    Go2PartHoleRadiusClass* obj = zHANDLE_POINTER(measurement);

    zCHECK(Go2System_CheckConfigurable(obj->system)); 
    obj->partialDetectionEnabled = enabled;
    zCHECK(Go2System_SetModified(obj->system));

    return GO2_OK;
}

GO2_EXPORT(Go2Bool) Go2PartHoleRadius_PartialDetectionEnabled(Go2Script measurement) 
{
    Go2PartHoleRadiusClass* obj = zHANDLE_POINTER(measurement); 

    return obj->partialDetectionEnabled;
}

GO2_EXPORT(Go2Status) Go2PartHoleRadius_EnableLink(Go2PartHoleRadius measurement, Go2Bool enable)  
{
    return Go2Measurement_EnableLink(measurement, enable);  
}

GO2_EXPORT(Go2Bool) Go2PartHoleRadius_LinkEnabled(Go2PartHoleRadius measurement)  
{
    return Go2Measurement_LinkEnabled(measurement);  
}

GO2_EXPORT(Go2Status) Go2PartHoleRadius_SetLink(Go2PartHoleRadius measurement, Go2UInt32 link) 
{
    return Go2Measurement_SetLink(measurement, link); 
}

GO2_EXPORT(Go2UInt32) Go2PartHoleRadius_Link(Go2PartHoleRadius measurement) 
{
    return Go2Measurement_Link(measurement); 
}

GO2_EXPORT(Go2PartRegion3d) Go2PartHoleRadius_Region(Go2PartHoleRadius measurement)
{
    return Go2PartMeasurement_Region(measurement);
}

GO2_EXPORT(Go2Status) Go2PartHoleRadius_EnableRegion(Go2PartHoleRadius measurement, Go2Bool enable)  
{
    return Go2PartMeasurement_EnableRegion(measurement, enable);  
}

GO2_EXPORT(Go2Bool) Go2PartHoleRadius_RegionEnabled(Go2PartHoleRadius measurement)  
{
    return Go2PartMeasurement_RegionEnabled(measurement);  
}


GO2_EXPORT(Go2UInt32) Go2PartHoleRadius_LinkOptionCount(Go2PartHoleRadius measurement)
{
    return Go2Measurement_LinkOptionCount(measurement);
}

GO2_EXPORT(Go2UInt32) Go2PartHoleRadius_LinkOptionAt(Go2PartHoleRadius measurement, Go2UInt32 index)
{
    return Go2Measurement_LinkOptionAt(measurement, index);
}
